<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Cours/TD - 10</TITLE>
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">

</HEAD>
<BODY BACKGROUND="../icons/arbk39.gif">
<!-- <BODY BACKGROUND="../icons/dcbk1.gif">  -->


<CENTER><H1>Cours/TD - (10)</H1>
</CENTER>
<P>
<p>


<TABLE width=100%>
 <TR><TD align=left><A HREF="comres9.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres11.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>
<FONT COLOR=#0000FF FACE="Helvetica,Arial" point-size=14pt>

<H3><FONT COLOR=#f00000>16.11.99</FONT></H3>
<p>


<H2>Cours</H2>

<H3>Optimisation des parseurs descendants</H3>

Nos parseurs sont <SPAN class=ib>nondéterministes</SPAN>, ce qui implique une certaine inefficacité. Sur le plan pratique, la nécessité de <I>backtracking</I> n'est pas grande, à condition que les grammaires soient correctement factorisées et normalisées. 
<p>

Le nondéterminisme est nuisible si le parseur suit une mauvaise route trop longtemps, ou s'il génère un nombre important de réponses nondéterministes "bidon", possédant une seule instance réelle. Si la décision concernant la branche de l'alternative nondéterministe est prise vite - par exemple tout de suite après l'acceptation du  premier item, et si on évite l'usage de l'alternative inclusive ALT, l'efficacité des parseurs monadiques est souvent parfaitement acceptable. Le cas le plus classique où la grammaire semble générer plusieurs solutions, mais le parsing est trivialement déterministe est notre grammaire d'expressions algébriques, où chaque terme et chaque facteur est une expression légale, mais on cherche toujours l'expression la plus longue. (Un cas encore plus trivial : toute séquence de lettres est un identificateur, mais on on ne s'arrête jamais pour mettre un "identificateur partiel" dans la liste de réponses.)
<p>


Néanmoins, si on envisage de faire un grand compilateur "industriel", qui est censé de compiler des centaines de milliers de lignes de code, la nécessité d'optiser les parseurs existe. Dans ce cas, d'habitude on n'utilise pas la technique descendante, mais les stratégies ascendantes LR(1), préférables pour des raisons d'universalité (et extensibilité du langage). Nous n'envisageons pas de décrire les détails de ces méthodes dans ce cours (elles seront pourtant brièvement discutées), car les "entrailles" de ces techniques sont lourdes et illisibles pour les débutants. Pour les maîtriser il faut lire très soigneusement leur spécification, et ceci nous aurait coûté trop de temps. 
<p>
Pour les utiliser pratiquement, et superficiellement, il suffit prendre un des générateurs de parseurs sur le "marché", par exemple Yacc/Bison, le générateur de parseurs en OCaml, etc. (Et, bien sûr, en lire la documentation...). Mais les parseurs descendants, simples et élégants peuvent aussi être optimisés. La discussion ci-dessous sera succinte et un peu incomplète.
<p>

<H4>Élimination de la récursivité</H4>
En fait, elle ne peut être <I>vraiment</I> éliminée, car les productions sont souvent récursives, et la récursivité y présente n'est pas terminale. Il s'agit de remplacer la gestion automatique de la pile système par nos piles privées. <EM>Il nous faudra renoncer de définir les symboles non-terminaux de la grammaire par des procédures.</EM> Ils seront tout simplement des données symboliques stockées dans des tableaux ou listes. Une production non-contextuelle est une association entre un symbole non-terminal et une liste de symboles. Elle ne sera pas "exécutée" directement, comme dans le cas du parsing monadique, mais une procédure de pilotage, une sorte de "<SPAN class=ib>machine virtuelle de parsing</SPAN>" va l'interpréter, en empilant et dépilant ce qu'il faut.
<p>

Un parseur descendant <I>prédictif</I> de ce genre est une boucle pilotée par un tableau spécial indexé par les objets <B>(A,s) : </B><B>M[A,s]</B>, où <B>A</B> est un non-terminal, et <B>s</B> - un terminal (y compris un terminal spécial <TT>($)</TT> qui dénote la fin du flot des lexèmes). La structure de donnée primaire du parseur est une pile capable de stocker les symboles de la grammaire. On l'initialise avec <TT>($)</TT> couvert par le symbole de départ de la grammaire (<B>"expr"</B>, ou <B>"programme"</B>, ou <B>"instruction"</B>, etc.)
<p>

Le parseur lors de chaque étape d'analyse regarde le symbole <B>X</B> qui se trouve au sommet de la pile, et <B>s</B> le lexème d'entrée. Son action suit les règles suivantes :
<UL type="square">
<LI> Si <B>X=s=$</B>, alors le parseur s'arrête. Sinon :
<LI> Si <B>X=s</B>, le parseur a reconnu une constante, un symbole terminal. <B>X</B> est dépilé, et la lecture du flot d'entrée progresse d'un item. (La stratégie ne précise pas ce que l'on doit faire avec ce terminal reconnu, c'est un problème sémantique qui demande l'attachement des procédures sémantiques aux productions de la grammaire).
<LI> Si <B>X</B> est un non-terminal, le tableau <B>M</B> est consulté. On récupère <B>M[X,s]</B> qui doit être une production (éventuellement une production d'erreur). Si c'est une règle <B>X :: alpha beta</B>, alors <B>X</B> est dépilé, et et il est remplacé par <B>beta, alpha</B>. Une procédure sémantique doit être aussi déclenchée.
</UL>
<p>

La construction explicite d'un tel parseur en Haskell n'est pas plus difficile que la construction de la machine virtuelle qui évaluait les expressions. Un excellent sujet d'examen.
<p>

Si une règle syntaxique contient une alternative : <B>X ::= alpha | beta</B>, on peut considérer ceci comme l'existence de deux règles indépendantes. Mais la transformation de <B>X ::= alpha (beta | gamma)</B> en deux règles <B>X ::= alpha beta</B> et <B>X ::= alpha gamma</B> est justement contraire à la règle de factorisation. Il faudra réécrire cela comme <B>X ::=alpha Y</B> ; <B>Y ::= beta | gamma</B>, où <B>Y</B> peut subir la transformation de séparation. Mais s'il y a plusieurs règles attachées à un non-terminal, laquelle doit être utilisée?


<H4>Les tableaux PREMIER et SUIVANT</H4>

Ceci est le rôle du second argument du parseur, le lexème <B>s</B>. Si le langage est bien défini, nous pouvons nous assurer, que la reconnaissance d'un lexème sur le flot d'entrée élimine tout nondéterminisme. ainsi, notre grammaire algébrique après la normalisation de Greibach contenait le symbole <TT>termlist</TT>, qui se réduisait à la chaîne vide si-et-seulement-si le symbole courant n'était pas un opérateur additif. En général, pour tout symbole qui se réduit finalement à une chaîne de terminaux <SPAN class=ib>alpha</SPAN> nous établissons un tableau spécial : PREMIER (ou FIRST en anglais), où FIRST(<SPAN class=ib>alpha</SPAN>) définit l'ensemble de tous les <SPAN class=ib>terminaux</SPAN> qui peuvent se trouver au début de la chaîne <SPAN class=ib>alpha</SPAN>. Pour un symbole terminal <B>p</B>, FIRST(<B>p</B>) se réduit à {<B>p</B>}. FIRST(<B>X</B>) peut aussi contenir la chaîne vide, mais attention, alors FIRST(<B>XY</B>) dépend de FIRST(<B>Y</B>) et n'est pas déterminé par <B>X</B>.
<p>

Donc, pour un non-terminal <B>X ::= Y<SUB>1</SUB> Y<SUB>2</SUB> ...</B> on trouve FIRST(<B>X</B>) en regardant FIRST(<b>Y<SUB>1</SUB> Y<SUB>2</SUB> ...</B>), ce qui souvent se réduit à FIRST(<B>Y<SUB>1</SUB></B>).

<HR WIDTH="45%" ALIGN=CENTER>

Pour chaque non-terminal <B>A</B> on construit un autre tableau : "SUIVANT", ou FOLLOW(<B>A</B>), qui contient l'ensemble de tous les terminaux qui peuvent apparaître à droite de <B>A</B> dans une phrase, c'est-à-dire, que peuvent suivre le développement de <B>A</B>. <SPAN class=ib>alpha</SPAN> appartient à FOLLOW(<B>A</B>), s'il existe une dérivation <B>S ::= x A <I>alpha</I> beta</B>.
<p>

Cette dérivation peut être déduite de la <I>production</I> pour <B>S</B>, et toutes autres règles utilisant les non-terminaux référencés par cette production. La construction du tableau FOLLOW procède récursivement, en réduisant les productions :
<UL>
<LI> Si dans <B>S ::= x A P beta</B>, <B>P</B> n'est pas un terminal, on récupère son FIRST.
<LI> Si <B>A</B> est défini par la production <B>A ::= alpha B</B>, tout dans FOLLOW(<B>A</B>) se retrouvera dans FOLLOW(<B>B</B>).
</UL> 
La programmation de ces tableaux à partir des règles est un joli exercice. Après leur création on peut construire le tableau <B>M</B> :
<UL>
<LI> Pour chaque terminal <B>a</B> dans FIRST(<B>alpha</B>), ajouter <B>A ::= alpha</B> à <B>M[A,a]</B>.
<LI> Si la chaîne vide se trouve dans FIRST(<B>alpha</B>), cette production : <B>A ::= alpha</B> est ajoutée à <B>M[A,b]</B> pour tout terminal <B>b</B> dans FOLLOW(<B>A</B>).
<LI> Faire la même chose pour le marqueur <B>$</B> : s'il se trouve dans FOLLOW(<B>A</B>) (normalement ceci est légal pour le symbole de départ, le programme entier), il faut ajouter la production courante dans <B>M[A,$]</B>.
<LI> Tous les autres éléments du tableau <B>M</B> déclenchent une erreur du parsing.
</UL>

Pour terminer: on n'est pas obligé de renoncer de notre philosophie monadique pour utiliser la technique optimisée. On peut définir les parseurs monadiques "augmentés" par des informations déduites de FIRST et FOLLOW, et éliminer la création des fragments des arbres du parsing inutiles, cependant ceci est une stratégie qui n'est pas très naturelle, et sa réalisation manuelle n'est pas facile. Si on a <I>vraiment</I> besoin d'optimiser le parseur, il serait également utile de supprimer la surcharge introduite par l'enchaînement monadique.

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif">
</CENTER>
<p>



<H3>Introduction à l'analyse ascendante</H3>

La stratégie descendante - répétons - consiste à remplacer un non-terminal <SPAN class=ib>postulé</SPAN> par un arbre résultant de l'application de la production définissant ce non-terminal. Les variables syntaxiques présentes dans l'arbre subissent la même réduction, et finalement l'arbre est construit "de haut en bas", à partir de la racine (vous savez que les informaticiens plantent les arbres à l'envers).
<p>

En tout cas on a besoin d'un automate à pile, récursif ou non. La même exigence concerne d'autres types de parseurs.
<p>

La stratégie ascendante construit l'arbre syntaxique à partir des feuilles. On consomme le flot de données, item par item, et à chaque étape on se pose la question : continuer a consommer ces items, <SPAN class=ib>et les empiler</SPAN>, ou dépiler les choses sauvegardées (jusqu'à un point spécifié), et remplacer leur liste par le symbole à gauche d'une production correspondante (empilé à son tour)? (En anglais ceci s'appelle le dilemme "<I>shift or reduce</I>").
<p>

Ici, comme dans la section précédente, les non-terminaux ne seront pas "procéduralisés", il existe <I>une</I> procédure (machine virtuelle) de parsing, qui interprète des tableaux contenant les productions, éventuellement d'autres données utiles, comme les attaches avec les procédures sémantiques, attributs, etc. Ce dernier élément est assez difficile à programmer de façon automatique, et pour cela, même si on trouve sur le "marché", p. ex. sur l'Internet, des milliers de parseurs - jouets, les générateurs de parseurs professionnels sont rares. Le monde utilise toujours l'immortel Yacc (ou Bison) non pas parce qu'il soit génial et irremplaçable, mais parce qu'il est là, et fonctionne raisonnablement bien. De plus, on sait que la classe de grammaires acceptée par les parseurs ascendants (LR) est plus large que celle appropriée aux méthodes descendantes. Ceci n'est pas forcément un argument critique, car rarement on envisage la création d'un langage super-complexe, cependant les techniques ascendantes semblent être plus appropriées pour l'analyse et la compilation des langages extensibles.
<p>

Parfois on note que les techniques ascendantes LR permettent de reconnaître une erreur de syntaxe plus rapidement. Nous pensons que, par contre, ceci <I>n'est pas</I> extrêmement important. Quand la compilation explose à cause des erreurs, ce n'est pas le temps latent entre la lecture d'un mauvais item et le diagnostic qui compte, mais le temps de déboguage... Par contre, le diagnostic doit signaler précisement l'endroit où la faute a été découverte.
<p>

Commençons par une stratégie plutôt simple et claire, utilisée par exemple dans Prolog, par l'interprète lui-même, et par plusieurs autres (simples) langages.

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif">
</CENTER>
<p>


<H3>Grammaires opérationnelles</H3>

Un modèle particulièrement simple et élégant est basé sur la possibilité de catégoriser tous les symboles syntaxiques d'une grammaire et de les séparer en deux classes : les <EM>opérateurs</EM>, et les "autres choses", les données. Ici les parenthèses sont des opérateurs spécifiques. 
<p>

Un opérateur est un symbole qui possède quelques propriétés (attributs) particuliers, notamment sa précédence et son associativité à gauche ou à droite - tout ceci est déjà intuitivement connu. Nous allons adopter la convention suivante :

<OL type="i">
<LI> Il n'y a pas d'associativité traitée comme une propriété indépendante, mais chaque opérateur dispose de <EM>deux précédences</EM> : gauche et droite. Ce sont des nombres entiers, positifs.
<LI> Dans l'expression <B>... x A y B z ...</B> où <B>A, B</B> sont les opérateurs infixes, si la précédence droite de <B>A</B> est supérieure à la précédence gauche de <B>B</B>, la phrase est parsée comme <B>... x A y) B z ...</B>, sinon, comme <B>... x A (y B z ...</B>. Donc, ces deux précédences remplacent complètement la définition de l'associativité.
<LI> On peut définir aussi des opérateurs préfixes et postfixes, qui agissent seulement à droite (ou à gauche).
<LI> Une classe utile d'opérateurs sont les opérateurs de parenthésage : "<B>()</B>", "<B>{}</B>", "<B>begin ... end</B>", etc., leur rôle est évident. Nous pouvons les marquer comme tels, en spécifiant que la précédence droite de "<B>(</B>" est égale à la précédence gauche de "<B>)</B>".
<LI> Il faut prévoir un opérateur spécial, disons <B>$</B>, de très faible précédence.
<LI> On peut introduire la classe d'opérateurs non-associatifs, qui déclenchent une exception si le programme les trouve à côté. C'est un problème important, et il n'est pas facile à résoudre sans introduire des procédures <I>ad hoc</I>.
</OL>

Le parseur opère avec deux piles : la pile de données, et celle d'opérateurs. (On peut faire tout avec une seule, mais avec deux l'algorithme est plus simple). La pile d'opérateurs est initialisée avec <B>$</B>. Ensuite le parseur lit le flot de lexèmes, et prend des décisions suivantes :
<UL>
<LI> Une donnée, c'est-à-dire un lexème qui n'est pas reconnu comme opérateur, est toujours empilée.
<LI> Un opérateur est comparé avec le dernier opérateur sur la pile. Si sa précédence est plus grande que celle de l'opérateur empilé, il est empilé à son tour.
<LI> Si elle est plus faible (naturellement, on compare la précédence gauche de l'opérateur actuel, avec la précédence droite de son prédécesseur empilé), l'opérateur empilé réduit la pile de données, et disparaît. L'opérateur courant est comparé avec ce qui reste sur la pile d'opérateurs.
<LI> Un opérateur préfixe est toujours empilé.
<LI> Un opérateur fermant une paire de parenthésage fait disparaître sont partenaire ouvrant. 
</UL>

Prenons, à titre d'exemple le parsing des expressions algébriques, avec les quatre opérations et les parenthèses. Voici une proposition de l'assignation des précédences :
<p>



<center>
<TABLE  width="60%" border="3" cellspacing="0" cellpadding="2" bgcolor="#80ffff" bordercolor="#800040">
	<TR>	<TD  align="center"><B>Op.</B></TD>
	<TD align="center"><B>Préc. gauche</B></TD>
 <TD align="center"><B>Préc. droite</B></TD>
	</TR>
	<TR>
	<TD align="center"><B>^</B></TD>
	<TD align="center">101</TD><TD align="center">100</TD>
	</TR>
	<TR>
	<TD align="center"><B>*</B></TD>
	<TD align="center">90</TD><TD align="center">91</TD>
	</TR>
	<TR>
	<TD align="center"><B>/</B></TD>
	<TD align="center">90</TD><TD align="center">91</TD>
	</TR>
	<TR>
	<TD align="center"><B>+</B></TD>
	<TD align="center">80</TD><TD align="center">81</TD>
	</TR>
	<TR>
	<TD align="center"><B>-</B></TD>
	<TD align="center">80</TD><TD align="center">81</TD>
	</TR>
	<TR>
	<TD align="center"><B>=</B></TD>
	<TD align="center">61</TD><TD align="center">60</TD>
	</TR>
	<TR>
	<TD align="center"><B>$</B></TD>
	<TD align="center">0</TD><TD align="center">0</TD>
	</TR>
	<TR>
	<TD align="center"><B>(</B></TD>
	<TD align="center">&nbsp;</TD><TD align="center">10</TD>
	</TR>
	<TR>
	<TD align="center"><B>)</B></TD>
	<TD align="center">10</TD><TD align="center">&nbsp;</TD>
	</TR>
</TABLE>
</center>

</font>
<p>
<FONT COLOR=#0000FF FACE="Helvetica,Arial" point-size=14pt>
<p>

Et voici les étapes du parsing de l'expression :
<PRE class="he">
<EM>$</EM> a - (2*c/y + 7*d) + f/g^2 <EM>$</EM>
</PRE>
<p>

<TABLE width=100% border=2 cellspacing="0" cellpadding="1" bgcolor="#E0ffE0" bordercolor="#800040">
<TR>
<TD align="center"><B>Flot restant</B></td><td align="center"><B>Pile d'opérateurs</B></td><td align="center"><B>Pile de données</B></td>
</tr><tr>
<td>-(2*c/y + 7*d) + f/g^2</td><td>&nbsp; </td><td>a</TD>
</TR><tr>
<td>(2*c/y + 7*d) + f/g^2</td><td>-</td><td>a</TD>
</TR><tr>
<td>2*c/y + 7*d) + f/g^2</td><td>-,(</td><td>a</TD>
</TR><tr>
<td>*c/y + 7*d) + f/g^2</td><td>-,(</td><td>a,2</TD>
</TR><tr>
<td>c/y + 7*d) + f/g^2</td><td>-,(,*</td><td>a,2</TD>
</TR><tr>
<td>/y + 7*d) + f/g^2</td><td>-,(,*</td><td>a,2,c</TD>
</TR><tr>
<td>/y + 7*d) + f/g^2</td><td>-,(</td><td>a,2*c</TD>
</TR><tr>
<td>y + 7*d) + f/g^2</td><td>-,(,/</td><td>a,2*c</TD>
</TR><tr>
<td>+ 7*d) + f/g^2</td><td>-,(,/</td><td>a,2*c,y</TD>
</TR><tr>
<td>+ 7*d) + f/g^2</td><td>-,(</td><td>a,(2*c)/y</TD>
</TR><tr>
<td>7*d) + f/g^2</td><td>-,(,+</td><td>a,(2*c)/y</TD>
</TR><tr>
<td>*d) + f/g^2</td><td>-,(,+</td><td>a,(2*c)/y,7</TD>
</TR><tr>
<td>d) + f/g^2</td><td>-,(,+,*</td><td>a,(2*c)/y,7</TD>
</TR><tr>
<td>) + f/g^2</td><td>-,(,+,*</td><td>a,(2*c)/y,7,d</TD>
</TR><tr>
<td>) + f/g^2</td><td>-,(,+</td><td>a,(2*c)/y,(7*d)</TD>
</TR><tr>
<td>) + f/g^2</td><td>-,(</td><td>a,((2*c)/y)+(7*d)</TD>
</TR><tr>
<td>+ f/g^2</td><td>-</td><td>a,(((2*c)/y)+(7*d))</TD>
</TR><tr>
<td>+ f/g^2</td><td>&nbsp; </td><td>a-(((2*c)/y)+(7*d))</TD>
</TR><tr>
<td>f/g^2</td><td>+</td><td>a-(((2*c)/y)+(7*d))</TD>
</TR><tr>
<td>/g^2</td><td>+</td><td>a-(((2*c)/y)+(7*d)),f</TD>
</TR><tr>
<td>g^2</td><td>+,/</td><td>a-(((2*c)/y)+(7*d)),f</TD>
</TR><tr>
<td>^2</td><td>+,/</td><td>a-(((2*c)/y)+(7*d)),f,g</TD>
</TR><tr>
<td>2</td><td>+,/,^</td><td>a-(((2*c)/y)+(7*d)),f,g</TD>
</TR><tr>
<td>$</td><td>+,/,^</td><td>a-(((2*c)/y)+(7*d)),f,g,2</TD>
</TR><tr>
<td>$</td><td>+,/</td><td>a-(((2*c)/y)+(7*d)),f,g^2</TD>
</TR><tr>
<td>$</td><td>+</td><td>a-(((2*c)/y)+(7*d)),f/(g^2)</TD>
</TR><tr>
<td>$</td><td>&nbsp; </td><td>(a-(((2*c)/y)+(7*d)))+(f/(g^2))</TD>
</TR>
</TABLE>
<p>
et le parsing est terminé. Bien sûr, la représentation des données sur la deuxième pile est symbolique, les opérations sont "exécutées" selon les règles sémantiques appropriées, les arbres intermédiaires sont formés ou le code correspondant généré.

</FONT>
<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/an_ledli.gif">
</CENTER>
<p>


<p>
<H2> &nbsp; TD &nbsp; </H2>
<p>

<H3>Construction des tableaux FIRST et FOLLOW</H3>
<p>
<FONT FACE="Helvetica,Arial" point-size=14pt>

Construirons ces tableaux pour notre grammaire préférée - celle d'expressions algébriques 
<PRE class="he">
<EM>1. </EM>Expr ::= Terme TermList
<EM>2. </EM>TermList ::= EPS
<EM>3. </EM>TermList ::= OpAdd Terme TermList

<EM>4. </EM>Terme ::= Facteur FctList
<EM>5. </EM>FctList ::= EPS
<EM>6. </EM>FctList ::= OpMul Facteur FctList

<EM>7. </EM>Facteur ::= Atome
<EM>8. </EM>Facteur ::= '(' Expr ')'

Atome ::= 'a' | 'b' | ...   -- lettre, ev. ident, ou nombre
</PRE>
<p>

<B>OpAdd</B> signifie naturellement '+' ou '-', et <B>OpMul</B> : '*' ou '/'.

<H4>First.</H4>
Un facteur ne possède pas de production vide, son FIRST est récupérable immédiatemment : c'est {atome, '('}.
<p>

La production 4 implique FIRST(Terme)=FIRST(Facteur), et la production 1:  FIRST(Expr)=FIRST(Terme).
<p>
Les productions 2 et 3 donnent : FIRST(TermList)={EPS,opAdd}, et 5,6 : FIRST(FctList)={EPS,opMul}
<p>

C'est tout. Les non-terminaux possédant la production vide ne figurent jamais devant un autre symbole, donc on a pas besoin d'appliquer la règle contextuelle.

<p><hr align=center width=50%><p>
<H4>Follow.</H4>

La seule règle explicite qui détermine le FOLLOW(Expr) est la règle 8, mais il ne faut pas oublier que Expr est le symbole de départ. Nous pouvons toujours dans ce cas ajouter une production implicite, "décorative" :
<PRE class="he">
LeTout ::= Expr $
</PRE>

Si on reconnait que les expressions forment à peine un sous-langage, qu'elles sont partie des listes, instructions, etc., par exemple 
<PRE class="he">
Instr ::= Var '=' Expr
Prog ::= Instr ';' Prog
</PRE>
etc., il sera alors possible de récupérer FOLLOW de ces autres règles. Il est donc évident qu'il n'est pas possible en général de construire le tableau FOLLOW pour un sous-langage. Il <SPAN class=ib>faut</SPAN> que le parsing de <B>leTout</B> se termine avec succès. Si on traite notre grammaire négligement, on peut supposer qu'un terme soit une expression légale même s'il se trouve au milieu d'autres termes. Ceci est erroné.
<p>

Par ailleurs, nous pouvons faire ici un commentaire-digression sur la différence entre "C" et Pascal. En "C" le point-virgule <SPAN class=ib>fait partie d'une instruction</SPAN>, c'est un <EM>terminateur</EM>. Dans <TT>if(<I>condition</I>) <I>instr</I>; else <I>instr</I>;</TT>, le point-virgule devant <TT>else</TT> est obligatoire. Par contre, en Pascal le point-virgule est un <EM>séparateur</EM>, il appartient à la production qui définit une <SPAN class=ib>suite d'instructions</SPAN>, comme ci-dessus. Il appartiendra alors à FOLLOW(Instr).
<p>
Retournons à notre exemple. Nous aurons donc FOLLOW(Expr)={')',$}. La production 1 implique alors que FOLLOW(TermList)=FOLLOW(Expr)={')',$}.
<p>
Le FOLLOW(Terme) peut et doit être récupéré du FIRST(TermList). Mais ce dernier contient la chaîne vide, alors il faut utiliser aussi son FOLLOW. On obtient FOLLOW(Terme)={opAdd,')',$}. Ceci est immédiatemment répercuté sur FOLLOW(FctList), grâce à la production 4.
<p>

Le reste suit les mêmes principes. FOLLOW(Facteur) utilise FIRST(FctList), et son FOLLOW à cause de la production vide. La réponse est FOLLOW(Facteur)={opMul,opAdd,')',$}.


<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif">
</CENTER>
<p>



<H3>Quelques autres opérateurs</H3>

Nous avons essayé d'analyser la structure des langages "classiques" de programmation, pour attribuer les précédences aux opérateurs relationnels, logiques, etc. Vous avez proposé d'attribuer à l'opérateur de relation "<B>&lt;</B>" les précédences (70,71), et <I>idem</I> pour <B>&gt;, ==, &lt;=; &gt;=</B>, et <B>&lt;&gt;</B> (ou <B>/=</B>). Mais ...
<p>


Question numéro 1 : quelle est la signification de la construction : <B>a &lt; b &lt; c</B>? Dans des textes mathématiques on trouve de telles expressions assez souvent. En Haskell, même si une telle combinaison avait été syntaxiquement légale (<EM>ce qui est faux !</EM>), le vérificateur de types aurait découver l'incompatibilité, car le type de résultat de l'opération de relation est Booléen. Pour éviter des problèmes, les opérateurs de relation sont déclarés en Haskell comme non-associatifs. Avec notre convention de double précédence il nous faut choisir une autre solution. Un de vous a proposé que l'on attribue à un tel opérateur deux précédences identiques. Cette proposition sera retenue, mais il faut avouer, qu'elle ne règle pas tous les problèmes sémantiques possibles, et la présence d'opérateurs non-associatifs complique le parseur opérationnel.
<p>

En "C" l'expression composite ci-dessus est légale (pas de Booléens, la relation retourne 0 ou 1), mais le résultat n'a rien à voir avec notre intuition.
<p>

Il existe un langage où l'enchaînement des relations est légale et "normale". En <B>Icon</B>, qui est un langage nondéterministe avec la synaxe similaire à celle du "C", la relation <B>a&lt;b</B> <SPAN class=ib>peut échouer</SPAN>. Si cela se produit, l'échec se propage, et le deuxième opérateur n'est pas exécuté. Mais en Icon le succès du "<B>&lt;</B>" retourne son <SPAN class=ib>second argument</SPAN>, c'est-à-dire <B>b</B>. On le peut alors comparer à <B>c</B>. Une telle sémantique est possible en Haskell, mais en dehors de la monade triviale (fonctionnelle, classique). Il faudrait utiliser une variante de la monade nondéterministe (ou Maybe, où l'échec ne signifie pas une erreur, mais l'équivalent d'une valeur logique "fausse" qui se propage).
<p>

Les opérateurs de conjonction et de disjonction Booléenne, p. ex. <B>&amp;&amp;</B> et <B>||</B> sont normalement associatifs à gauche, et leur précédence se trouve en dessous des opérateurs relationnels, et au dessus de l'affectation "<B>=</B>". La précédence de la conjonction ("et" : <B>&amp;&amp;</B>) est normalement supérieure à celle de la disjonction ("ou" : "||").

<H3>Structures de contrôle comme opérateurs</H3>

<H4>La conditionnelle</H4>

La conditionnelle <TT>if ... then ... else</TT> dans un langage fonctionnel est une expression qui retourne une valeur. (La clause <TT>else</TT> est donc obligatoire.) Entre <TT>if</TT> et <TT>then</TT> - et <TT>else</TT> on trouve dans le programme toute sorte d'opérations arithmétiques, relationnels, etc. On peut donc augmenter le tableau de précédences par quelques lignes, comme ci-dessous :
<p>

<center>
<TABLE  width="60%" border="3" cellspacing="0" cellpadding="2" bgcolor="#80ffff" bordercolor="#800040">
	<TR>	<TD  align="center"><B>Op.</B></TD>
	<TD align="center"><B>Préc. gauche</B></TD>
 <TD align="center"><B>Préc. droite</B></TD>
	</TR>
	<TR>
	<TD align="center"><B>&lt;</B></TD>
	<TD align="center">75</TD><TD align="center">75</TD></TR><TR>
	<TD align="center"><B>&gt;</B></TD>
	<TD align="center">75</TD><TD align="center">75</TD></TR><TR>
	<TD align="center"><B>==</B></TD>
	<TD align="center">75</TD><TD align="center">75</TD></TR><TR>
	<TD align="center"><B>if</B></TD>
	<TD align="center">&nbsp; </TD><TD align="center">65</TD></TR><TR>
	<TD align="center"><B>then</B></TD>
	<TD align="center">70</TD><TD align="center">70</TD>
	</TR>
	<TR>
	<TD align="center"><B>else</B></TD>
	<TD align="center">73</TD><TD align="center">73</TD>
	</TR>
</TABLE>
</center>
<p>

</font>
<FONT FACE="Helvetica,Arial" point-size=14pt>

Cette solution n'est pas unique. <TT>if</TT> est évidemment un opérateur préfixe. Les précédences relatives de <TT>then</TT> et <TT>else</TT> ne sont pas déterminées, ceci dépend de notre stratégie de construction de l'arbre :
<p>

<CENTER><IMG SRC="opcond.gif"></CENTER>
<p>
Donc, les deux possibilités : la précédence du <TT>then</TT> supérieure à celle du <TT>else</TT>, ou inférieure, sont acceptables. les deux opérateurs sont non-associatifs. La sémantique (fonctionnelle) de cette expression, réalisée dans un langage strict (non-paresseux) est un peu délicate. Mais rappelons-nous ce que nous avons fait avec <TT>if</TT> dans notre langage interprété postfixe : <TT>if</TT> (ou <TT>ifelse</TT>) étaient des fonctions parfaitement standard, mais elles prenaient comme arguments des procédures (une ou deux, des <I>thunks</I> sans paramètres), dont l'exécution a été différée et contrôlée par <TT>if</TT> selon le résultat de l'évaluation de la condition. Donc, la construction d'une arborescence correspondant à cette structure de contrôle doit être suivie par un traitement sémantique qui construit, par exemple :
<p>

<CENTER><IMG SRC="iftrait.gif" WIDTH="287" HEIGHT="198" ALT=""></CENTER>
<p>

où, comme avant, les clauses sont des expressions figurant dans <TT>if</TT>, après <TT>then</TT> ou<TT>else</TT>. Une "procéduralisation" des structures de contrôle est souvent simple à implanter et à comprendre, mais elle ajoute des charges supplémentaires à l'exécution : création des instances des <I>thunks</I>, y compris la gestion des variables non-locales dans les thunks ; l'empilement de l'adresse de retour, etc. Une implantation de plus bas niveau serait évidemment envisageable.
<p>


<H4>Les appels fonctionnels</H4>
<p>

Retournons aux problèmes strictement syntaxiques. Comment utiliser les grammaires d'opérateurs pour compiler un langage contenant les appels fonctionnels, p. ex <TT>f(x,y)</TT>, ou même <TT>(f x y)</TT> en Haskell? Sémantiquement on sait que si un identificateur précède un autre (ou une liste parenthésée d'expressions), il s'agit d'un appel fonctionnel. Mais si le parseur le considère comme une donnée, et s'il empile tout, qui et quand effectuera la réduction de cet appel?
<p>

Une possible stratégie s'appuie sur le traitement de tout objet qui peut être un opérateur comme un opérateur. Une constante numérique, ou une chaîne est une donnée, mais un identificateur <b>f</b> peut être considéré comme un opérateur de très haute précédence. Il est empilé sur la pile des ops, et dépilé immédiatemment s'il est suivi par un opérateur infixe classique. Il et alors considéré comme un opérateur sans arguments, et transporté sur la pile des données comme une expression réduite. S'il est suivi par une donnée, p. ex. par un autre identificateur <b>g</b>, celui force la réduction, et formation de <b>(f g)</b>, qui reste sur la pile des opérateurs, et le parsing continue.
<p>

L'implantation de cette stratégie est un joli exercice. Il faut avouer cependant, que le parseur devient assez complexe, la gestion des erreurs est parfois problématique, et en général cette technique de parsing est utilisable pour les langages <SPAN class=ib>simples</SPAN>.

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif">
</CENTER>
<p>




<TABLE width=100%>
 <TR><TD align=left><A HREF="comres9.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres11.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>


</FONT>
</BODY>

</HTML>
